#include "sl_alloc_test.h"


void
test_it(Uint sbct)
{
    int no_changes;
    int bi;
    int min_sz;
    int prev_bi;
    int sz;
    
    init_bucket_index(sbct);
    no_changes = 0;
    prev_bi = -1;

    printf("Testing with sbct = %d\n", (int) sbct);

    fflush(stdout);

    for (sz = MIN_BLK_SZ; sz < 100000000; sz++) {
	bi = BKT_IX(sz);
	if (prev_bi != bi) {
	    if (prev_bi + 1 != bi) {
		printf("\n\nprev_bi=%d; this=%d\n", prev_bi, bi);
		fflush(stdout);
		FAIL_TEST;
	    }
		
	    if (prev_bi >= 0)
		printf("; ");

	    min_sz = BKT_MIN_SZ(bi);

	    if (sz != min_sz) {
		printf("\n\nsz=%d -> ix=%d -> min_sz=%d\n", sz, bi, min_sz);
		fflush(stdout);
		FAIL_TEST;
	    }

	    printf("sz=%d->ix=%d", sz, bi);
	    fflush(stdout);
	    no_changes++;
	}
	prev_bi = bi;
    }
    printf("\n\n");
    fflush(stdout);
    if (no_changes != NO_OF_BKTS) {
	printf("No of changes = %d!\n", no_changes);
	fflush(stdout);
	FAIL_TEST;
    }
    


}


START_TEST
{
    ErtsSlAllocInit esai;

    if (!test_new_sl_alloc)
	SKIP_TEST("Cannot test old sl_alloc");

    memset((void *) &esai, 255, sizeof(ErtsSlAllocInit));
    esai.esla = 1;
    esai.eosla = 0;

    erts_sl_alloc_init(&esai);

    printf("No of buckets = %d:\n\n", NO_OF_BKTS);

    test_it(1024);
    test_it(esai.sbct);
    test_it(1024*1024);
    test_it(10*1024*1024);

    TEST_SUCCEEDED;
}
END_TEST
