#include "sl_alloc_test.h"

#define SBC_THRESHOLD 8192
#define NO_OF_BLOCKS   7
#define NO_OF_ALLOC_OPS_PER_BLOCK 1000

Uint alloc_seq_1[] = {
  SBC_THRESHOLD,     /* mmap */
  SBC_THRESHOLD*4,   /* mmap to new mmap */
  SBC_THRESHOLD/50,  /* mmap to malloc */
  SBC_THRESHOLD,     /* malloc to mmap */
  0
};


Uint alloc_seq_2[] = {
  1,
  SBC_THRESHOLD/10,
  SBC_THRESHOLD/9,
  SBC_THRESHOLD/8,
  SBC_THRESHOLD/7,
  SBC_THRESHOLD/6,
  SBC_THRESHOLD/5,
  SBC_THRESHOLD/4,
  SBC_THRESHOLD/3,
  SBC_THRESHOLD/2,
  SBC_THRESHOLD*1,
  SBC_THRESHOLD*2,
  SBC_THRESHOLD*3,
  SBC_THRESHOLD*4,
  SBC_THRESHOLD*5,
  SBC_THRESHOLD*6,
  SBC_THRESHOLD*7,
  SBC_THRESHOLD*8,
  SBC_THRESHOLD*9,
  SBC_THRESHOLD*10,
  SBC_THRESHOLD*9,
  SBC_THRESHOLD*8,
  SBC_THRESHOLD*7,
  SBC_THRESHOLD*6,
  SBC_THRESHOLD*5,
  SBC_THRESHOLD*4,
  SBC_THRESHOLD*3,
  SBC_THRESHOLD*2,
  SBC_THRESHOLD*1,
  SBC_THRESHOLD/2,
  SBC_THRESHOLD/3,
  SBC_THRESHOLD/4,
  SBC_THRESHOLD/5,
  SBC_THRESHOLD/6,
  SBC_THRESHOLD/7,
  SBC_THRESHOLD/8,
  SBC_THRESHOLD/9,
  SBC_THRESHOLD/10,
  1,
  0
};

Uint alloc_seq_3[] = {
  SBC_THRESHOLD*11,
  SBC_THRESHOLD*10,
  SBC_THRESHOLD*9,
  SBC_THRESHOLD*8,
  SBC_THRESHOLD*7,
  SBC_THRESHOLD*6,
  SBC_THRESHOLD*5,
  SBC_THRESHOLD*4,
  SBC_THRESHOLD*3,
  SBC_THRESHOLD*2,
  SBC_THRESHOLD*1,
  SBC_THRESHOLD/2,
  SBC_THRESHOLD/3,
  SBC_THRESHOLD/4,
  SBC_THRESHOLD/5,
  SBC_THRESHOLD/6,
  SBC_THRESHOLD/7,
  SBC_THRESHOLD/8,
  SBC_THRESHOLD/9,
  SBC_THRESHOLD/10,
  1,
  SBC_THRESHOLD/10,
  SBC_THRESHOLD/9,
  SBC_THRESHOLD/8,
  SBC_THRESHOLD/7,
  SBC_THRESHOLD/6,
  SBC_THRESHOLD/5,
  SBC_THRESHOLD/4,
  SBC_THRESHOLD/3,
  SBC_THRESHOLD/2,
  SBC_THRESHOLD*1,
  SBC_THRESHOLD*2,
  SBC_THRESHOLD*3,
  SBC_THRESHOLD*4,
  SBC_THRESHOLD*5,
  SBC_THRESHOLD*6,
  SBC_THRESHOLD*7,
  SBC_THRESHOLD*8,
  SBC_THRESHOLD*9,
  SBC_THRESHOLD*10,
  0
};

Uint alloc_seq_4[] = {
  SBC_THRESHOLD*1,
  SBC_THRESHOLD*10,
  SBC_THRESHOLD*1,
  0
};

Uint alloc_seq_5[] = {
  SBC_THRESHOLD/50,
  SBC_THRESHOLD*10,
  SBC_THRESHOLD/50,
  0
};

Uint alloc_seq_6[] = {
  SBC_THRESHOLD/50,
  SBC_THRESHOLD*10,
  SBC_THRESHOLD/50,
  SBC_THRESHOLD*10,
  0
};

Uint alloc_seq_7[] = {
  1,
  SBC_THRESHOLD/50,
  SBC_THRESHOLD*10,
  SBC_THRESHOLD/50,
  0
};


block blocks[NO_OF_BLOCKS] = {{NULL, 0, 0, alloc_seq_1},
			      {NULL, 0, 0, alloc_seq_2},
			      {NULL, 0, 0, alloc_seq_3},
			      {NULL, 0, 0, alloc_seq_4},
			      {NULL, 0, 0, alloc_seq_5},
			      {NULL, 0, 0, alloc_seq_6},
			      {NULL, 0, 0, alloc_seq_7}};

START_TEST
{
  int i, j;
  ErtsSlAllocInit esai;

  memset((void *) &esai, 255, sizeof(ErtsSlAllocInit));
  esai.esla = 1;
  esai.eosla = !test_new_sl_alloc;
  esai.sbct = SBC_THRESHOLD;
  esai.mmc = 5000;
  
  erts_sl_alloc_init(&esai);

  for(i = 0; i < NO_OF_ALLOC_OPS_PER_BLOCK; i++)
    for(j = 0; j < NO_OF_BLOCKS; j++)	
      alloc_op(&blocks[j], j + 1, 0);

  for(j = 0; j < NO_OF_BLOCKS; j++)
    alloc_op(&blocks[j], j + 1, 1);

  TEST_SUCCEEDED;
}
END_TEST
